﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Text.RegularExpressions;

using Microsoft.SiteAnalyzer.ForumPageExtractor;

namespace Microsoft.SiteAnalyzer.PostExtractor
{
    class Program
    {
        [STAThread]
        static void Main(string[] args)
        {
            string baseDir = @"D:\SiteAnalyzer2\private\data\ForumData\chunkData\";
            string outputDir = @"D:\SiteAnalyzer2\private\data\ForumData\result\";
            string forum = "asp";
            string inputPath = baseDir + forum + @"\PostRawPage\";

            PostPageExtractor curPostExtractor = PostPageExtractor.GetInstance(forum);

            List<string> samplingPages = GetTrainingPages(inputPath, "HTM");
            curPostExtractor.Training(samplingPages);
            curPostExtractor.SaveFeatures(inputPath, forum);
            curPostExtractor.LoadFeatures(inputPath, forum);

            int processNum = 1;
            foreach (string file in Directory.GetFiles(inputPath, "*.html"))
            {
                Console.WriteLine(file + "\t" + (processNum++).ToString());
                try
                {
                    string domFileName = outputDir + Path.GetFileNameWithoutExtension(file) + ".dom.xml";
                    string resFileName = outputDir + Path.GetFileNameWithoutExtension(file) + ".res.xml";

                    List<PostInfo> postList = curPostExtractor.ExtractorMain(file, domFileName);
                    PostInfoIOHelper.SaveExtractResult(postList, resFileName);
                }
                catch (Exception e)
                {
                    Console.WriteLine(e.Message);
                }
            }
        }

        static List<string> GetTrainingPages(string inputPath, string inputFilePattern)
        {
            List<string> fileList = new List<string>();
            int ct = 0;
            foreach (string file in Directory.GetFiles(inputPath, "*" + inputFilePattern))
            {
                fileList.Add(file);
                ct++;
                if (ct >= Utility.MAX_NUM_SAMPLING_PAGE) break;
            }
            return fileList;
        }
    }
}
