using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Web;

using Microsoft.SiteAnalyzer.Core;

namespace Microsoft.SiteAnalyzer.RandomSampler
{
    public class PageSampler
    {
        public static List<PageInfo.OutLink> GetFollowingUrls(List<PageInfo.OutLink> candidates, int depth, int nMax)
        {
            List<PageInfo.OutLink> selects = new List<PageInfo.OutLink>();

            if (candidates.Count <= nMax)
            {
                foreach (PageInfo.OutLink link in candidates)
                {
                    selects.Add(link);
                }
                return selects;
            }

            int[] selectId = new int[candidates.Count];
            for (int i = 0; i < selectId.Length; i++)
            {
                selectId[i] = i;
            }

            Random rand = new Random();
            for (int i = 0; i < nMax; i++)
            {
                int id = rand.Next(i, selectId.Length - 1);
                selects.Add(candidates[selectId[id]]);
                selectId[id] = selectId[i];
            }
            
            return selects;
        }
    }
}
